[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[PATCH 3/3] Add an initscript for the hurd console
From: |
Justus Winter |
Subject: |
[PATCH 3/3] Add an initscript for the hurd console |
Date: |
Wed, 17 Jul 2013 13:09:06 +0200 |
---
debian/changelog | 1 +
debian/hurd.hurd-console.init | 121 +++++++++++++++++++++++++++++++++++++++++
2 files changed, 122 insertions(+)
create mode 100644 debian/hurd.hurd-console.init
diff --git a/debian/changelog b/debian/changelog
index 81b9e56..adde108 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -2,6 +2,7 @@ hurd (20130707-2) UNRELEASED; urgency=low
[ Justus Winter ]
* Include the umount utility in hurd and hurd-udeb.
+ * Add an initscript for hurd-console.
[ Samuel Thibault ]
* Bump Standards-Version to 3.9.4 (no changes).
diff --git a/debian/hurd.hurd-console.init b/debian/hurd.hurd-console.init
new file mode 100644
index 0000000..bb15b8b
--- /dev/null
+++ b/debian/hurd.hurd-console.init
@@ -0,0 +1,121 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: hurd-console
+# Required-Start: $all
+# Required-Stop:
+# Default-Start: 1 2 3 4 5
+# Default-Stop: 0 6
+# Short-Description: Example initscript
+# Description: This file should be used to construct scripts to be
+# placed in /etc/init.d.
+### END INIT INFO
+
+# Author: Justus Winter <4winter@informatik.uni-hamburg.de>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/bin
+DESC="Hurd console multiplexer"
+NAME=console
+DAEMON=/bin/$NAME
+DAEMON_ARGS="--daemonize -D /home/teythoon/repos/hurd-upstream/console-client
-d current_vcs -c /dev/vcs"
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/hurd-$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/hurd-$NAME ] && . /etc/default/hurd-$NAME
+
+# Augment the arguments.
+DAEMON_ARGS="${DAEMON_ARGS} ${DISPLAY} ${KBD} ${KBD_REPEAT} \
+ ${SPEAKER} ${MOUSE} ${MOUSE_REPEAT}"
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON
--test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+ $DAEMON_ARGS \
+ || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile
$PIDFILE --name $NAME
+ RETVAL="$?"
+
+ [ "$?" = 2 ] && return 2
+ # Many daemons don't delete their pidfiles when they exit.
+ #rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "hurd-$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "hurd-$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc "$DAEMON" "hurd-$NAME" && exit 0 || exit $?
+ ;;
+ restart|force-reload)
+ log_daemon_msg "Restarting $DESC" "hurd-$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
+
+:
--
1.7.10.4
- add daemonizing support to console-client, initscript, Justus Winter, 2013/07/17
- [PATCH 2/3] Add (build) dependency on libdaemon, Justus Winter, 2013/07/17
- [PATCH 1/3] console-client: add daemonizing support, Justus Winter, 2013/07/17
- [PATCH 3/3] Add an initscript for the hurd console,
Justus Winter <=
- Re: [PATCH 3/3] Add an initscript for the hurd console, Justus Winter, 2013/07/17
- [PATCH 3/4] Add an initscript for the hurd console, Justus Winter, 2013/07/17
- Re: [PATCH 1/4] console-client: add daemonizing support, Samuel Thibault, 2013/07/26
- [PATCH 1/5] Add configure checks for libdaemon, Justus Winter, 2013/07/26
- [PATCH 2/5] console-client: add daemonizing support, Justus Winter, 2013/07/26
- [PATCH 3/5] debian/control: Add build dependency on libdaemon, Justus Winter, 2013/07/26